import scipy as sp
import numpy as np
import sys
from os import listdir
import matplotlib.cbook
import warnings
from tg_alti_stats_fun import tgAltiStats

def genStats_allTg(mission):
    # mission : altimetry mission. Choices are: 'j1j2j3' (Jasons), 's3a' (Sentinel-3A), and 's3b' (Sentinel-3B)
    #-------------------------------- parameters ------------------------------
    distMax = 300 # maximum distance from tide gauge in km
    dx = 5 # interval for distance from coast in km
    #--------------------------------------------------------------------------

    path2Tg = '/Shared/Data/TideGauge/C-RISe_TG_validation/'
    folders = ["C-RISe_UHSLC/","C-RISe_IOCSLMF/"]
    # find names of all tide gauges that have hourly data
    tgNames = []
    for fld in folders:
        fni = listdir(path2Tg + fld) # list files in directory
        fni = [x for x in fni if (x[0] != ".") and (x[-3:]=="t2k")]
        fni = [x.split("TS_")[-1][0:-4] for x in fni]
        tgNames.extend(fni)


    path2Alti = "/Shared/Data/C-RISe/altimetryByPass/"
    path2TgMonthly = '/Shared/Data/TideGauge/C-RISe_Seasonal_Variability/'
    path2Coast = "/Shared/Software/Windows/SeaLevel/SeaLevelValidation/"
    pathOut = '/Shared/Software/Windows/SeaLevel/SeaLevelValidation/data/'

    for tgn in tgNames:
        print(tgn)
        with warnings.catch_warnings():
            warnings.simplefilter("ignore", category=matplotlib.cbook.mplDeprecation)
            warnings.simplefilter("ignore", category=RuntimeWarning)
            tgAltiStats(tgn,mission,distMax,dx,path2Alti,path2Tg,path2TgMonthly,path2Coast,pathOut)

if __name__ == "__main__":
    import sys
    genStats_allTg(sys.argv[1])

        
        




 
