import numpy as np
import cPickle
import warnings
#from readAltiData import readAlti
from readAltiData_nc import readAlti #added 27 Feb 2018 (reads Alti from new colocated netcdf data)
from minDistance import minDistance
from plotSeries import plotSeries
import matplotlib.cbook
from os import listdir
import datetime
from plotAllTracks import plotAllTracks
import time

def plotSeriesSelect():
    path2Alti = "/Shared/Data/C-RISe/altimetryByPass/"
    xs,ys = plotAllTracks()
    with warnings.catch_warnings():
        warnings.simplefilter("ignore", category=matplotlib.cbook.mplDeprecation)

        listAlti = listdir(path2Alti) # list files in directory
        passes = [x[0:-3].split('p')[-1] for x in listAlti if 'j1j2' in x]
        for p in passes:
            # read data
	    dati = readAlti(path2Alti,p)
	    xa = dati["lon"]
	    ya = dati["lat"]
	    dx,kx = minDistance(xs,ys,xa,ya,100)
	    dx = dx[0]/1000.
	    if dx < 40:
	        h = dati["ssha"] + dati["dac"]
	        t = dati["time"]
	        h = h[:,int(kx[0])]
	        t = t[:,int(kx[0])]
	        break
	if 'h' not in locals():
	    print "No data available for that point"
	    
	else:
	    knan = ~np.isnan(h) & ~np.isnan(t)
	    h = h[knan]
	    t = t[knan]
	    h = h - np.mean(h)
	    h = h*100
	    td = [datetime.datetime.utcfromtimestamp(x) for x in t.tolist()]
            t0 = [datetime.datetime(x.year,1,1,0,0) for x in td]
            tf = [datetime.datetime(x.year+1,1,1,0,0,0) for x in td]
            tdec = [x.year + (x - y).days/float((z - y).days) for x,y,z in zip(td,t0,tf)]
            plotSeries(tdec,h)


if __name__ == "__main__":
    import sys
    plotSeriesSelect()
