import matplotlib.pyplot as plt
import matplotlib as mpl
import numpy as np
mpl.rcParams.update(mpl.rcParamsDefault)

def plot_series_maxCorr(t,y1,y2,tgName,passn,mission):

    fig = plt.figure(1,figsize=(18/2.54, 12/2.54))
    plt.plot(t,y1,linewidth=1.,color='k',label=r'Altimetry')
    plt.plot(t,y2,linewidth=1.,color='#E24A33',label=r'Tide gauge')

    hl = plt.legend(loc=0,labelspacing=0.5,borderpad=0.1,handlelength=1.5,\
                    ncol=1) 
    hl.draw_frame(False)
    hl.get_frame().set_linewidth(0.0)  
 
    plt.ylabel(r'Sea level (cm)')
    plt.xlabel('Year')
    plt.rc('font',size=15)
    plt.draw()
    plt.tight_layout()
    plt.xlim((t[0],t[-1]))
    plt.grid(b=1,linestyle='-',linewidth=0.1)
    ax = plt.gca()
    ax.get_xaxis().get_major_formatter().set_scientific(False)
    ax.ticklabel_format(useOffset=False)
    #plt.ylim((5,16))
    plt.subplots_adjust(top=0.9)

    pathFig = '/Shared/Software/Windows/SeaLevel/SeaLevelValidation/figures/'
    #fig.savefig(pathFig + "corr_dist2Coast_p" + passn + "_" + tgName + ".tiff",format = 'tiff', dpi = 300)
    fig.savefig(pathFig + "series_maxCorr_p" + passn + "_" + tgName + '_' + mission + ".png",format = 'png', dpi = 100)
    plt.close("all")

