import scipy as sp
import numpy as np
import sys
import warnings
from scipy.io import loadmat
#from os import listdir
from netCDF4 import Dataset
    
def readAlti(path2Data,passNumber,mission):
    #listAlti = listdir(path2Data) # list files in directory
    #mission = [x.split('_')[0] for x in listAlti if ('j1j2j3' in x) or ('n1sa' in x)][0]
    fln = mission + '_cmems_p%04d.nc' %(int(passNumber))
    fid = Dataset(path2Data + fln,'r')

    t = fid.variables["time"][:] # seconds since 1 Jan 2000
    t = t + 10957*24*3600. # Convert to POSIX timestamp (1970-1-1)
    x = fid.variables["lon"][:]
    y = fid.variables["lat"][:]
    ssha = fid.variables["ssha_filt"][:]
    if (np.ma.is_masked(ssha)):
        ssha = np.ma.getdata(ssha)
    dac = fid.variables["DACorr"][:]
    if (np.ma.is_masked(dac)):
        dac = np.ma.getdata(dac)
    ssha = ssha.T
    dac = dac.T
    
    inds = np.argsort(y)
    y = y[inds]
    x = x[inds]
    ssha = ssha[:,inds]
    dac = dac[:,inds]
    t = np.tile(t,(y.shape[0],1))
    t = t.T
    
    dataAll = {"lon":x,"lat":y,"time":t,"ssha":ssha,"dac":dac,"passNumber":str(int(passNumber))}
    return dataAll
 
