import scipy as sp
import numpy as np
import sys
import datetime
from calendar import monthrange
import os

def readTgMonthly(path2Data,tgName):

    idName = np.genfromtxt("/Shared/Software/Windows/SeaLevel/SeaLevelValidation/stationName.txt", dtype="i8,S30",delimiter="\t")
    idName = [(x[0],' '.join(str(x[1]).split())) for x in idName]
    idName = [(x[0],x[1].replace(" ","_")) for x in idName] # PSMSL id and names
    idTg = [x[0] for x in idName]
    names = [x[1] for x in idName]
    tgName = tgName.replace(" ","_")
    kid = [tgName.lower() in x.lower() for x in names]
    if tgName[-1].isdigit and ~any(x for x in kid):
        kid = [tgName[0:-2].lower() in x.lower() for x in names] # checking if the name has a number at the end
    
    if any(x for x in kid):
        kid = [i for i,x in enumerate(kid) if x][0]
        idTg = idTg[kid]
        fn = os.listdir(path2Data + "PSMSL_data/" + "PSMSL_RLR/")
        fn = [x for x in fn if "rlrdata" in x and str(idTg) in x]
        if fn:
            data = np.loadtxt(path2Data + "PSMSL_data/" + "PSMSL_RLR/" + fn[0],delimiter=';')
            data[data == -99999] = np.NaN
            data[:,1] = data[:,1]/1000.
        else:
            fn = os.listdir(path2Data + "PSMSL_data/" + "PSMSL_metric/")
            fn = [x for x in fn if "metdata" in x and str(idTg) in x]
            if fn:
                data = np.loadtxt(path2Data + "PSMSL_data/" + "PSMSL_metric/" + fn[0],delimiter=';')
                data[data == -99999] = np.NaN
                data[:,1] = data[:,1]/1000.
    if "data" in locals(): # if this TG is in the PSMSL and also the data are in our folder
        sl = data[:,1]
        t = data[:,0]
        #convert dates to second from epoch
        yeart = t.astype(int)
        epoch = datetime.datetime.utcfromtimestamp(0) # 1970-01-01 00:00:00
        year0 = [datetime.datetime(x,1,1) for x in yeart.tolist()]
        rem = (t - yeart).tolist()
        t0 = [datetime.datetime(x.year,1,1,0,0) for x in year0]
        tf = [datetime.datetime(x.year+1,1,1,0,0,0) for x in year0]
        ndays = [float((y - x).days) for x,y in zip(t0,tf)]
        t = [(x - epoch).total_seconds() + (y*z)*24.*3600 for x,y,z in zip(year0,rem,ndays)]
    else:
        fni = os.listdir(path2Data + "IOC_SLMF_data/")
        fn = [x for x in fni if tgName.lower() in x.lower()]
        if tgName[-1].isdigit and not fn:
            fn = [x for x in fni if tgName[0:-2].lower() in x.lower()]
        if fn:
            with open(path2Data + "IOC_SLMF_data/" + fn[0]) as myFile:
                data = myFile.readlines()[3:]
                kannual = [i for i,x in enumerate(data) if "Annual" in x][0]
                data = data[0:kannual]
                data = [x.split() for x in data] 
                data = [x for x in data if x]
                data = np.asarray(data).astype(np.float)
                data[data == -999.999] = np.NaN
            sl = data[:,2]
            nm = data[:,3]
            yr = data[:,0].astype(int).tolist()
            mo = data[:,1].astype(int).tolist()
            sl[nm < 5] = np.NaN # at least 5 daily values to compute monthly mean
            epoch = datetime.datetime.utcfromtimestamp(0) # 1970-01-01 00:00:00
            t = [datetime.datetime(x,y,monthrange(x,y)[1]) for x,y in zip(yr,mo)]
            t = [(x - epoch).total_seconds() for x in t]

    # store data in dictionary
    if "t" not in locals():
        t = np.array([np.NaN])
        sl = np.array([np.NaN])
    else:
        t = np.asarray(t)
    dataTg = {"tgName":tgName,"dateEpoch":t,"sea_level":sl}
    return dataTg
